# Hunter's Bomb Timer Addon
#  
# Install instructions:
#       1. Install Mattie's EventScripts 2.0 plugin:
#           http://mattie.info/cs/
#
#       2. Copy and upload this script to:
#           <gamedir>/addons/eventscripts/bomb_timer/
#
#       3. Add the following line somewhere in autoexec.cfg:
#           es_load bomb_timer
#
################################################################################
#import EventScripts
import es
#import Libraries
import gamethread
import keyvalues
import langlib
import playerlib
import settinglib
import time
#import Psyco Compiler
import psyco
psyco.full()

# Addon Information
info = es.AddonInfo()
info.name = "Bomb Timer"
info.version = "4.0.0"
info.author = "Hunter"
info.url = "http://addons.eventscripts.com/addons/user/289"
info.description = "C4 Bomb Timer that counts down to explosion"
info.basename = "bomb_timer"

hunter_bomb_timer_ver      = info.version
hunter_bomb_timer_text     = 'Hunters '+info.name+', www.sourceplugins.de, '+info.version+', ES 2.0.0.247+ (Python Version)'

# Server Variables
bomb_timer_savetime        = es.ServerVar('bomb_timer_savetime', '30', 'How much days should inactive users be stored, before their settings get deleted? ( default = 30 )')
bomb_timer_soundload       = es.ServerVar('bomb_timer_soundload', '1', 'Should the sounds be downloaded with EventScripts?')
bomb_timer_endannounce     = es.ServerVar('bomb_timer_endannounce', '1', 'Should BOMB DEFUSED or BOMB EXPLODED be annouced at the end of a round?')
bomb_timer_middle_screen   = es.ServerVar('bomb_timer_middle_screen', '1', 'Should the bomb timer be shown in the middle of the screen? ( 0 = off | 1 = HudHint | 2 = CenterMsg )')
bomb_timer_default_display = es.ServerVar('bomb_timer_default_display', '1', 'Default settings for new connecting players')
bomb_timer_default_text    = es.ServerVar('bomb_timer_default_text', '1', 'Default settings for new connecting players')
bomb_timer_default_sound   = es.ServerVar('bomb_timer_default_sound', '1', 'Default settings for new connecting players')

# Global Variables
bomb_timer_mp_c4timer      = es.ServerVar('mp_c4timer')
bomb_timer_language        = langlib.Strings(es.getAddonPath('bomb_timer')+'/bomb_timer.ini')

# KeyValues Object
bomb_timer_kv              = keyvalues.KeyValues(name='bomb_timer')

# Settinglib Object
bomb_timer_setting         = settinglib.create('bombtimer', 'Bomb Timer Settings', 'toggle')

def load():
    public = es.ServerVar('hu_bt', info.version, info.name)
    public.makepublic()

    bomb_timer_kv.load(es.getAddonPath('bomb_timer')+'/bomb_timer.txt')

    bomb_timer_setting.addoption('display', 'Display')
    bomb_timer_setting.addoption('text', 'Text')
    bomb_timer_setting.addoption('sound', 'Sound')
    bomb_timer_setting.setdefault('display', int(bomb_timer_default_display))
    bomb_timer_setting.setdefault('text', int(bomb_timer_default_text))
    bomb_timer_setting.setdefault('sound', int(bomb_timer_default_sound))
    bomb_timer_setting.addsound('ui/buttonclick.wav')

    es.regsaycmd('!bombtimer', 'bomb_timer/saycmd', 'Bomb Timer Settings')
    es.log(hunter_bomb_timer_text)
    es.msg('#multi', '#green[BombTimer] #defaultLoaded')
    
def unload():
    gamethread.cancelDelayed('bomb_timer')

    es.unregsaycmd('!bombtimer')
    es.msg('#multi', '#green[BombTimer] #defaultUnloaded')
    
def es_map_start(event_var):
    bomb_timer_setting.clear(int(bomb_timer_savetime)*86400)
    if int(bomb_timer_soundload):
        for keyname in bomb_timer_kv:
            if str(keyname)[:6] == 'sounds':
                for soundname in bomb_timer_kv[str(keyname)]:
                    es.stringtable('downloadables', 'sound/'+str(bomb_timer_kv[str(keyname)][str(soundname)]))

def es_client_command(event_var):
    if (str(event_var['command']) == '!hunter_bomb_timer_ver') or (str(event_var['command']) == '!hunter_all_ver'):
        es.cexec(int(event_var['userid']), 'echo '+hunter_bomb_timer_text)

def player_activate(event_var):
    bomb_timer_setting.updateTime(int(event_var['userid']))
    gamethread.delayed(30, es.cexec, (int(event_var['userid']), 'echo '+hunter_bomb_timer_text))
    gamethread.delayed(15, es.tell, (int(event_var['userid']), '#multi', '#green[BombTimer] #defaultSay \'!bombtimer\' for settings menu'))

def player_disconnect(event_var):
    bomb_timer_setting.updateTime(int(event_var['userid']))

def bomb_planted(event_var):
    gamethread.delayedname(1, 'bomb_timer', bomb_ticker, (int(time.time())))
    _run_bomb('P')
    
def bomb_ticker(tick):
    gamethread.delayedname(1, 'bomb_timer', bomb_ticker, (tick))
    remaining = int(bomb_timer_mp_c4timer) - int(int(time.time()) - tick)
    _run_bomb(str(remaining))

def round_start(event_var):
    gamethread.cancelDelayed('bomb_timer')

def round_end(event_var):
    gamethread.cancelDelayed('bomb_timer')
    if int(event_var['reason']) == 1:
        _run_bomb('E')
    elif int(event_var['reason']) == 7:
        _run_bomb('D')

def saycmd():
    bomb_timer_setting.send(int(es.getcmduserid()))

def _run_bomb(ticker):
    if str(ticker) in bomb_timer_kv['commands'].keys():
        command = str(bomb_timer_kv['commands'][str(ticker)])
        if (';' in command):
            commandlist = command.split(';')
            for command in commandlist:
                es.ServerCommand(command.strip())
        else:
            es.ServerCommand(command.strip())
    if str(ticker).isdigit():
        soundtext = str(ticker)+' sec'
    elif str(ticker) == 'P':
        soundtext = 'Bomb Planted'
    elif str(ticker) == 'E':
        soundtext = 'Bomb Exploded'
    elif str(ticker) == 'D':
        soundtext = 'Bomb Defused'
    if int(bomb_timer_middle_screen) == 1:
        es.usermsg('create', 'bombtimer', 'HintText')
        es.usermsg('write', 'short', 'bombtimer', '-1')
        es.usermsg('write', 'string', 'bombtimer', str(soundtext))
    elif int(bomb_timer_middle_screen) == 2:
        es.usermsg('create', 'bombtimer', 'TextMsg')
        es.usermsg('write', 'byte', 'bombtimer', '4')
        es.usermsg('write', 'string', 'bombtimer', str(soundtext))
    useridlist = playerlib.getUseridList('#human')
    for userid in useridlist:
        if bomb_timer_setting.get('display', userid):
            if int(bomb_timer_middle_screen) > 0:
                es.usermsg('send', 'bombtimer', str(userid))
        if bomb_timer_setting.get('text', userid):
            if 'bomb_'+str(ticker) in bomb_timer_language.keys():
                player = playerlib.getPlayer(userid)
                soundtext = bomb_timer_language('bomb_'+str(ticker), {}, player.get("lang"))
                es.tell(userid, '#multi', soundtext)
        if bomb_timer_setting.get('sound', userid):
            if int(es.getplayerteam(userid)) < 2:
                keyname = 'sounds_spec'
            elif int(es.getplayerteam(userid)) == 2:
                keyname = 'sounds_t'
            elif int(es.getplayerteam(userid)) == 3:
                keyname = 'sounds_ct'
            if str(ticker) in bomb_timer_kv[str(keyname)].keys():
                soundfile = str(bomb_timer_kv[str(keyname)][str(ticker)])
                es.playsound(userid, soundfile, 1.0)
    if int(bomb_timer_middle_screen) > 0:
        es.usermsg('delete', 'bombtimer')
